<?php

/*
 * Class Name : GFHANNANSMS_Pro_{strtoupper( php file name) }	
 */

class GFHANNANSMS_Pro_SUNWAY {

	/*
	* Gateway title	
	*/
	public static function name( $gateways ) {

		$name = __( 'سان وی (SunWay)', 'GF_SMS' );

		$gateway = array( strtolower( str_replace( 'GFHANNANSMS_Pro_', '', get_called_class() ) ) => $name );

		return array_unique( array_merge( $gateways, $gateway ) );
	}


	/*
	* Gateway parameters
	*/
	public static function options() {
		return array(
			'username' => __( 'نام کاربری', 'GF_SMS' ),
			'password' => __( 'پسورد', 'GF_SMS' )
		);
	}

	/*
	* Gateway credit
	*/
	public static function credit() {
		return true;
	}


	/*
	* Gateway action
	*/
	public static function process( $options, $action, $from, $to, $messages ) {

		if ( $action == 'credit' && ! self::credit() ) {
			return false;
		}

		if ( ! extension_loaded( 'soap' ) ) {
			return __( 'ماژول Soap بر روی هاست شما فعال نمی باشد .', 'GF_SMS' );
		}


		$username = $options['username'];
		$password = $options['password'];

		if ( function_exists( 'ini_set' ) ) {
			ini_set( "soap.wsdl_cache_enabled", "0" );
		}

		$to = explode( ',', $to );
		$i  = sizeOf( $to );
		while ( $i -- ) {
			$uNumber = Trim( $to[ $i ] );
			$ret     = &$uNumber;
			if ( substr( $uNumber, 0, 5 ) == '%2B98' ) {
				$ret = substr( $uNumber, 5 );
			}
			if ( substr( $uNumber, 0, 5 ) == '%2b98' ) {
				$ret = substr( $uNumber, 5 );
			}
			if ( substr( $uNumber, 0, 4 ) == '0098' ) {
				$ret = substr( $uNumber, 4 );
			}
			if ( substr( $uNumber, 0, 3 ) == '098' ) {
				$ret = substr( $uNumber, 3 );
			}
			if ( substr( $uNumber, 0, 3 ) == '+98' ) {
				$ret = substr( $uNumber, 3 );
			}
			if ( substr( $uNumber, 0, 2 ) == '98' ) {
				$ret = substr( $uNumber, 2 );
			}
			$to[ $i ] = '0' . $ret;
		}

		$to = array_unique( $to );

		if ( $action == "send" ) {

			try {

				$client = new SoapClient( 'http://sms.sunwaysms.com/SMSWS/SOAP.asmx?wsdl' );

				$send = @$client->SendArray( array(
					'UserName'        => $username,
					'Password'        => $password,
					'RecipientNumber' => $to,
					'MessageBody'     => $messages,
					'SpecialNumber'   => $from,
					'IsFlashMessage'  => false,
					//'CheckingMessageID' => array_pad( array(), count( $to ), rand( 1000000, 9999999 ) )
				) )->SendArrayResult->long;

				if ( ! empty( $send ) ) {
					$send   = (array) $send;
					$errors = array();
					foreach ( $send as $item ) {
						if ( $item < 1000 ) {
							$errors[] = self::fault( $item );
						}
					}

					return ! empty( $errors ) ? implode( ' | ', array_unique( $errors ) ) : 'OK';
				}

				return __( 'خطای ناشناخته.', 'GF_SMS' );

			} catch ( SoapFault $sf ) {
				return $sf->getMessage();
			}
		}


		if ( $action == "credit" ) {

			try {

				$client = new SoapClient( 'http://sms.sunwaysms.com/SMSWS/SOAP.asmx?wsdl' );

				$credit = $client->GetCredit( array(
					'UserName' => $username,
					'Password' => $password
				) )->GetCreditResult;

				if ( in_array( $credit, array( '51', '52', '60', '63', '70', '77', '78', '80', '666', '777' ) ) ) {
					return self::fault( $credit );
				}

				return $credit;

			} catch ( SoapFault $sf ) {
				return $sf->getMessage();
			}
		}

		if ( $action == "range" ) {
			$min = 100;
			$max = 500;

			return array( "min" => $min, "max" => $max );
		}
	}

	private static function fault( $code ) {

		switch ( $code ) {

			case '51':
				return __( 'نام کاربری یا رمز عبور اشتباه است.', 'GF_SMS' );
				break;

			case '52':
				return __( 'نام کاربری یا رمز عبور خالی است.', 'GF_SMS' );
				break;

			case '53':
				return __( 'طول آرایه گیرندگان (‫‪RecipientNumber‬‬) بیش از حد مجاز (1000) است.', 'GF_SMS' );
				break;

			case '54':
				return __( 'گیرنده خالی است.', 'GF_SMS' );
				break;

			case '55':
				return __( 'گیرنده نامعتبر است.', 'GF_SMS' );
				break;

			case '59':
				return __( 'متن پیامک خالی است.', 'GF_SMS' );
				break;

			case '60':
				return __( 'به دلیل ترافیک بالای سامانه بعدا تلاش کنید.', 'GF_SMS' );
				break;

			case '61':
				return __( 'شماره فرستنده نامعتبر است یا مربوط به شما نیست.', 'GF_SMS' );
				break;

			case '62':
				return __( 'شماره فرستنده خالی است.', 'GF_SMS' );
				break;

			case '63':
				return __( 'این IP اجازه دسترسی به وبسرویس را ندارد. برای افزودن IP از بخش وبسرویس داخل سامانه پیامکی اقدام کنید.', 'GF_SMS' );
				break;

			case '70':
				return __( 'کاربر غیرفعال شده است.', 'GF_SMS' );
				break;

			case '77':
				return __( 'شما کاربر وبسرویس نیستید.', 'GF_SMS' );
				break;

			case '78':
				return __( 'شما کاربر سامانه مدیریت ارسال و دریافت پیام کوتاه نیستید.', 'GF_SMS' );
				break;

			case '80':
				return __( 'در حال حاضر وبسرویس توسط ADMIN غیرفعال شده است. بعدا تلاش کنید.', 'GF_SMS' );
				break;

			case '201':
				return __( 'فرمت شماره گیرندگان صحیح نیست. خطای 201 رخ داده است.', 'GF_SMS' );
				break;

			case '202':
				return __( 'امکان ارسال پیامک به یکی از اپراتور شماره گیرندگان وجود ندارد.', 'GF_SMS' );
				break;

			case '203':
				return __( 'اعتبار پیامک برای ارسال کافی نیست.', 'GF_SMS' );
				break;

			case '666':
				return __( 'سرویس موقتا غیرفعال است.', 'GF_SMS' );
				break;

			case '777':
				return __( 'این IP مسدود است.', 'GF_SMS' );
				break;

			default:
				return sprintf( __( 'خطای شماره %s رخ داده است.', 'GF_SMS' ), $code );
		}
	}

}